; ---------------------------------------------------------------------------
;  Algo #01  to test and code to manage the display of the results.
; ---------------------------------------------------------------------------

;---------------------------------------------------------------------------------------
; MACRO to convert unsigned DWORD into NULL terminated ASCII string 
;---------------------------------------------------------------------------------------

.data
; ---------------------------------------------------------------------------
;  put here the description of your algo to test. max 30 chars.
; ---------------------------------------------------------------------------
; -------------------------[123456789012345678901234567890]------------------

align Four

    AlgoDesc1        byte  "ustrv$ + GetNumberFormat      ",0

align Four
    
    AlgoSize         dword EndAlgo1 - Algo1   

align Four

    NumToTest        dword 0
                     dword 9
                     dword 10
                     dword 99
                     dword 100
                     dword 999
                     dword 1000
                     dword 9999
                     dword 10000
                     dword 99999
                     dword 100000
                     dword 999999
                     dword 1000000
                     dword 9999999
                     dword 10000000
                     dword 99999999
                     dword 100000000
                     dword 999999999
                     dword 1000000000
                     dword 4294967295 

    PtrNumToTest     dword NumToTest

    NumFormat        db  20 dup (0) 
    PtrNumFormat     dword NumFormat
    TheNumIs         dword 0 

; ---------------------------------------------------------------------------

.code

align 4

    jmp  Start1

Algo1:

align 4

AlgoN1 proc

; ----------------------------------------------------------------------
;  put here your algo to test
; ----------------------------------------------------------------------

    lea  esi, NumToTest

    xor  ecx, ecx
    mov  ecx, 20

StartConvert:

    mov  eax, [esi]
    mov  TheNumIs, eax
    
    push esi
    push ecx 

    mov PtrNumFormat, ustrv$(TheNumIs, offset NumFormat)

    invoke GetNumberFormat, NULL, 0, PtrNumFormat, offset NumFmt, 
                            offset BufNum, 255

    pop  ecx
    pop  esi

    add  esi, Four
    dec  ecx
    jnz  StartConvert        
  

    ret

; ----------------------------------------------------------------------
;  end point of algo to test
; ----------------------------------------------------------------------

AlgoN1 endp 

EndAlgo1:



Start1:

ALIGN 4

    invoke AssignStr, addr AlgoDesc, offset AlgoDesc1, 
                      dword ptr MaxLenStr


    invoke DisplayAt, dword ptr AlgoColDesc, dword ptr AlgoRow, addr AlgoDesc, 
                      dword ptr AlgoDescSize

    .if ( AlgoSize > 99 )

        sub  AlgoColSize, One

    .endif

    mov PtrAlgoSizeStr, ustrv$(AlgoSize, offset AlgoSizeStr)

    mov AlgoSizeStrLen, len(PtrAlgoSizeStr) 

    invoke DisplayAt, dword ptr AlgoColSize, dword ptr AlgoRow, addr AlgoSizeStr, 
                      dword ptr AlgoSizeStrLen 

    .if ( AlgoSize > 99 )

        add  AlgoColSize, One

    .endif

StartAlgo1:

    invoke Sleep, 100
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS

; ------------------------------------------------------------------------------
;  algo to test is called here
; ------------------------------------------------------------------------------

    call AlgoN1

; ------------------------------------------------------------------------------

    counter_end

    mov AlgoTicks, eax 

    invoke FormatNumX, AlgoTicks, PtrAlgoTicksStr;

    mov    StringLenght, len (PtrAlgoTicksStr)

    .if  ( StringLenght < 9 )

            mov  eax, 9
            
            sub  eax, [StringLenght]

            add  AlgoColTicks, eax
            
    .endif 

    invoke DisplayAt, dword ptr AlgoColTicks, dword ptr AlgoRow, addr AlgoTicksStr, 
                         dword ptr StringLenght

NextTest1: 

    inc    TestDone

    mov    eax, TestToDo

    .if TestDone >= eax

        mov  TestDone, Zero

        jmp  EndTestAlgo1

    .endif

    .if  ( StringLenght < 9 )

         mov  eax, 9
            
         sub  eax, [StringLenght]

         sub  AlgoColTicks, eax
            
    .endif 

    add AlgoColTicks, ColTicksDisplacement

    jmp StartAlgo1

EndTestAlgo1:

    mov AlgoColTicks, ColTicksInit

    add AlgoRow, Two

; ###########################################################################

