; ---------------------------------------------------------------------------
;  Algo #4  to test and code to manage the display of the results.
;  Replace the "4" with the number of Algo you are inserting. 
; ---------------------------------------------------------------------------

.data
; ---------------------------------------------------------------------------
;  put here the description of your algo to test. max 30 chars.
; ---------------------------------------------------------------------------
; -------------------------<123456789012345678901234567890>------------------
    AlgoDesc4        byte  "Clive - IDIV and Stack        ",0
; ---------------------------------------------------------------------------

.code

align 4

    mov  AlgoSize, (EndAlgo4  - Algo4 ) 

    jmp  Start4 

Algo4 :

align 4

AlgoN4  proc

; ----------------------------------------------------------------------
;  put here your code to test
; ----------------------------------------------------------------------

; EAX = 32-bit number
; ESI = string buffer for NUL terminated ASCII
; Uses ESI,EDI,EAX,ECX,EDX,EBX

    xor  ebx, ebx
    mov  ebx, 20
    lea  eax, NumToTest
    mov  PtrNumToTest, eax

ConvertNext4:

    lea  esi, NumFormat ; Helps to initialize it every time round

    mov  eax, PtrNumToTest
    mov  eax, [eax]

    push 0           ; Mark stack end with NUL

divloop:

    mov  ecx,1000       ; Divide into 3 digit groups
    xor  edx,edx ; Clear high order 32-bit for divide
    idiv ecx ; eax = edx:eax / ecx, edx = edx:eax % ecx

    mov  edi,eax ; Save division result

    mov  ecx,10      ; Subdivide in 10's
    mov  eax,edx ; Get remainder

    or   edi,edi      ; Still number left, so at least 3 digits in remainder
    jnz  digit000

    cmp  eax,10 ; remainder has one digit
    jb   digit0

    cmp  eax,100 ; remainder has two digits
    jb   digit00

digit000:               ; 3 digits

    xor  edx,edx      ; Clear high order 32-bit for divide
    idiv ecx            ; eax = edx:eax / ecx, edx = edx:eax % ecx
    add  edx,30h      ; += '0'
    push edx      ; Stack

digit00:               ; 2 digits

    xor  edx,edx        ; Clear high order 32-bit for divide
    idiv ecx            ; eax = edx:eax / ecx, edx = edx:eax % ecx
    add  edx,30h        ; += '0'
    push edx            ; Stack

digit0:           ; 1 digit

if 0
    xor  edx,edx        ; Clear high order 32-bit for divide
    idiv ecx            ; eax = edx:eax / ecx, edx = edx:eax % ecx
    add  edx,30h        ; += '0'
    push edx            ; Stack
else
                        ; The digit here (IN EAX) is 0 to 9 no need to divide
    add  eax,30h        ; += '0'
    push eax            ; Stack
endif

    mov  eax,edi ; Recover remaining number

    or   eax,eax ; Zero?
    jz   poploop

    push 2Ch ; Comma added to groups of three digits
    jmp  divloop

poploop:

    pop  eax ; Recover next digit
    mov  [esi],al      ; Add to string
    inc  esi
    or   eax,eax ; Was it a NUL?
    jnz  poploop

    push ebx
    push esi

; -----------------------------------------------------------------
;    print ADDR NumFormat,13,10
;    print sstr$(ebx),13,10,10
; -----------------------------------------------------------------

    pop  esi
    pop  ebx

    add  PtrNumToTest, Four ; Next number to convert
    sub  ebx, One
    jnz  ConvertNext4

    ret

; ----------------------------------------------------------------------
;  end point of algo to test
; ----------------------------------------------------------------------

AlgoN4  endp 

EndAlgo4 :



Start4 :

ALIGN 4

    invoke AssignStr, addr AlgoDesc, offset AlgoDesc4 , 
                      dword ptr MaxLenStr


    invoke DisplayAt, dword ptr AlgoColDesc, dword ptr AlgoRow, addr AlgoDesc, 
                      dword ptr AlgoDescSize

    .if ( AlgoSize > 99 )

        sub  AlgoColSize, One

    .endif

    mov PtrAlgoSizeStr, ustrv$(AlgoSize, offset AlgoSizeStr)

    mov AlgoSizeStrLen, len(PtrAlgoSizeStr) 

    invoke DisplayAt, dword ptr AlgoColSize, dword ptr AlgoRow, addr AlgoSizeStr, 
                      dword ptr AlgoSizeStrLen 

    .if ( AlgoSize > 99 )

        add  AlgoColSize, One

    .endif

StartAlgo4 :

    invoke Sleep, 100
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS

; ------------------------------------------------------------------------------
;  algo to test is called here
; ------------------------------------------------------------------------------

    call AlgoN4 

; ------------------------------------------------------------------------------

    counter_end

    mov AlgoTicks, eax 

    invoke FormatNumX, AlgoTicks, PtrAlgoTicksStr;

    mov    StringLenght, len (PtrAlgoTicksStr)

    .if  ( StringLenght < 9 )

            mov  eax, 9
            
            sub  eax, [StringLenght]

            add  AlgoColTicks, eax
            
    .endif 

    invoke DisplayAt, dword ptr AlgoColTicks, dword ptr AlgoRow, addr AlgoTicksStr, 
                         dword ptr StringLenght

NextTest4 : 

    inc    TestDone

    mov    eax, TestToDo

    .if TestDone >= eax

        mov  TestDone, Zero

        jmp  EndTestAlgo4 

    .endif

    .if  ( StringLenght < 9 )

         mov  eax, 9
            
         sub  eax, [StringLenght]

         sub  AlgoColTicks, eax
            
    .endif 

    add AlgoColTicks, ColTicksDisplacement

    jmp StartAlgo4 

EndTestAlgo4 :

    mov AlgoColTicks, ColTicksInit

    add AlgoRow, Two

; ###########################################################################

